// ILBlinkyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ILBlinky.h"
#include "ILBlinkyDlg.h"
#include "TcpIp.h"
#include "Redeye.h"

#define VERSION   "1.01"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CILBlinkyApp theApp;

#ifdef _DEBUG
LPCTSTR szNoTitle = _T("ILBlinky ")_T(VERSION)_T(" Debug");
#else
LPCTSTR szNoTitle = _T("ILBlinky ")_T(VERSION);
#endif

static const LPCTSTR szLicence =
	_T("This program is free software; you can redistribute it and/or modify\r\n")
	_T("it under the terms of the GNU General Public License as published by\r\n")
	_T("the Free Software Foundation; either version 2 of the License, or\r\n")
	_T("(at your option) any later version.\r\n")
	_T("\r\n")
	_T("This program is distributed in the hope that it will be useful,\r\n")
	_T("but WITHOUT ANY WARRANTY; without even the implied warranty of\r\n")
	_T("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\r\n")
	_T("See the GNU General Public License for more details.\r\n")
	_T("\r\n")
	_T("You should have received a copy of the GNU General Public License along\r\n")
	_T("with this program; if not, write to the Free Software Foundation, Inc.,\r\n")
	_T("51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.");

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	SetDlgItemText(IDC_VERSION,szNoTitle);
	SetDlgItemText(IDC_LICENSE,szLicence);

	return TRUE;  // return TRUE unless you set the focus to a control
				  // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CILBlinkyDlg dialog

CILBlinkyDlg::CILBlinkyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CILBlinkyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CILBlinkyDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_strAddrOut = _T("localhost");
	m_uPortOut   = 60000;
	m_uPortIn    = 60001;

	m_dwConnectTimeout = 0xFFFFFFFF;		// client connect timeout in us (default blocked connect timeout)

	m_strUdpServer = _T("localhost");
	m_uUdpPort     = 5025;

	for (UINT i = 0; i < 256; ++i)			// initialize character translation table
	{
		m_vbyConvert.push_back(i);
	}

	m_bAutoExtAddr = TRUE;					// HP-IL auto extended address support

	m_pComObj = nullptr;					// interface object class
	m_pRedeye = nullptr;					// Blinky device
}

CILBlinkyDlg::~CILBlinkyDlg()
{
	delete m_pRedeye;						// Blinky device
}

/////////////////////////////////////////////////////////////////////////////
// CILBlinkyDlg settings helper functions

CString CILBlinkyDlg::ReadString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault)
{
	if (*theApp.m_szIniFile != 0)
	{
		TCHAR cBuffer[1024];

		::GetPrivateProfileString(lpszSection,lpszEntry,lpszDefault,cBuffer,ARRAYSIZEOF(cBuffer),theApp.m_szIniFile);
		return CString(cBuffer);
	}
	else
	{
		return AfxGetApp()->GetProfileString(lpszSection,lpszEntry,lpszDefault);
	}
}

UINT CILBlinkyDlg::ReadInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nDefault)
{
	if (*theApp.m_szIniFile != 0)
	{
		return ::GetPrivateProfileInt(lpszSection,lpszEntry,nDefault,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->GetProfileInt(lpszSection,lpszEntry,nDefault);
	}
}

BOOL CILBlinkyDlg::WriteString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszValue)
{
	if (*theApp.m_szIniFile != 0)
	{
		return ::WritePrivateProfileString(lpszSection,lpszEntry,lpszValue,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->WriteProfileString(lpszSection,lpszEntry,lpszValue);
	}
}

BOOL CILBlinkyDlg::WriteInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nValue)
{
	if (*theApp.m_szIniFile != 0)
	{
		TCHAR s[16];
		wsprintf(s,_T("%u"),nValue);
		return ::WritePrivateProfileString(lpszSection,lpszEntry,s,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->WriteProfileInt(lpszSection,lpszEntry,nValue);
	}
}

void CILBlinkyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CILBlinkyDlg)
	DDX_Control(pDX, IDC_START, m_CButStart);
	DDX_Control(pDX, IDC_STOP, m_CButStop);
	DDX_Text(pDX, IDC_UDPSERVER, m_strUdpServer);
	DDX_Text(pDX, IDC_UDPPORT, m_uUdpPort);
	DDX_Text(pDX, IDC_ADDR_OUT, m_strAddrOut);
	DDX_Text(pDX, IDC_PORT_OUT, m_uPortOut);
	DDX_Text(pDX, IDC_PORT_IN, m_uPortIn);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CILBlinkyDlg, CDialog)
	ON_MESSAGE(WM_INTERFACESTOPPED, OnInterfaceStopped)

	//{{AFX_MSG_MAP(CILBlinkyDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CILBlinkyDlg message handlers

BOOL CILBlinkyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "Help Topics..." and "About..." menu items to the system menu.

	// IDM_HELPTOPICS must be in the system command range.
	ASSERT((IDM_HELPTOPICS & 0xFFF0) == IDM_HELPTOPICS);
	ASSERT(IDM_HELPTOPICS < 0xF000);

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		CString strText;
		pSysMenu->AppendMenu(MF_SEPARATOR);

		strText.LoadString(IDS_HELP_TOPICS);
		pSysMenu->AppendMenu(MF_STRING, IDM_HELPTOPICS, strText);

		strText.LoadString(IDS_ABOUTBOX);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strText);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
//	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	CString strText;

	m_CButStart.EnableWindow(TRUE);
	m_CButStop.EnableWindow(FALSE);

	if (*theApp.m_szIniFile != 0)			// ini file given
	{
		CString strTitle;

		// new document title
		GetWindowText(strTitle);
		strTitle += CString(_T(" - ")) + theApp.m_lpFilePart;
		SetWindowText(strTitle);	// set document title with ini file
	}

	// get actual window position
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);

	// load positions from registry if available
	m_nPosX      = ReadInt(_T("Settings"),_T("WinPosX"),wndpl.rcNormalPosition.left);
	m_nPosY      = ReadInt(_T("Settings"),_T("WinPosY"),wndpl.rcNormalPosition.top);

	m_strAddrOut = ReadString(_T("Settings"),_T("AddrOut"),m_strAddrOut);
	m_uPortOut   = ReadInt(_T("Settings"),_T("PortOut"),m_uPortOut);
	m_uPortIn    = ReadInt(_T("Settings"),_T("PortIn"),m_uPortIn);
	m_dwConnectTimeout = ReadInt(_T("Settings"),_T("ConnectTimeout"),m_dwConnectTimeout);

	m_strUdpServer = ReadString(_T("Settings"),_T("UdpServer"),m_strUdpServer);
	m_uUdpPort     = ReadInt(_T("Settings"),_T("UdpPort"),m_uUdpPort);

	m_bAutoExtAddr = ReadInt(_T("Settings"),_T("AutoExtAddr"),m_bAutoExtAddr);

	// read character translation table
	for (UINT nAddr = 0; nAddr < m_vbyConvert.size(); ++nAddr)
	{
		TCHAR cAddr[8];

		wsprintf(cAddr, _T(":%u"), nAddr);
		m_vbyConvert[nAddr] = static_cast<BYTE>(ReadInt(_T("Translate"),cAddr,m_vbyConvert[nAddr]));
	}

	SetWindowLocation(m_nPosX,m_nPosY);		// set windows location

	// initialize the internal instrument
	m_pRedeye = new CRedeye(m_vbyConvert,m_strUdpServer,m_uUdpPort,m_bAutoExtAddr != FALSE);

	// set new DEVID$ for redeye printer
	m_pRedeye->SetAID(ReadInt(_T("Settings"),_T("AID"),m_pRedeye->GetAID()));
	m_pRedeye->SetID$(ReadString(_T("Settings"),_T("ID$"),m_pRedeye->GetID$()));

	UpdateData(FALSE);

	// press the "Start" button
	if (theApp.m_bStart) PostMessage(WM_COMMAND,IDC_START);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CILBlinkyDlg::PreTranslateMessage(MSG* pMsg)
{
	// TODO: Add your specialized code here and/or call the base class
	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE)
	{
		return TRUE;  // disable the ESC key quitting the application
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CILBlinkyDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	switch (nID & 0xFFF0)
	{
	case IDM_HELPTOPICS:
		ShellExecute(GetSafeHwnd(),
					 _T("open"),
					 _T("ILBlinky.htm"),
					 NULL,
					 _T(""),
					 SW_SHOWNORMAL);
		break;
	case IDM_ABOUTBOX:
		CAboutDlg().DoModal();
		break;
	default:
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CILBlinkyDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CILBlinkyDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// set window location
VOID CILBlinkyDlg::SetWindowLocation(INT nPosX,INT nPosY)
{
	WINDOWPLACEMENT wndpl;
	RECT *pRc = &wndpl.rcNormalPosition;

	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);
	pRc->right = pRc->right - pRc->left + nPosX;
	pRc->bottom = pRc->bottom - pRc->top + nPosY;
	pRc->left = nPosX;
	pRc->top = nPosY;
	SetWindowPlacement(&wndpl);
	return;
}

void CILBlinkyDlg::OnStart()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	// setup the device with actual UDP settings
	m_pRedeye->SetInfraredConfiguration(m_strUdpServer,m_uUdpPort);

	// create the communication interface
	m_pComObj = new CTcpIp(m_pRedeye,m_strAddrOut,m_uPortOut,m_uPortIn,m_dwConnectTimeout,this);

	if (m_pComObj != nullptr)
	{
		if (m_pComObj->StartServer() == true) // init server
		{
			m_CButStart.SetButtonStyle(BS_PUSHBUTTON);
			m_CButStart.EnableWindow(FALSE);
			m_CButStop.EnableWindow(TRUE);
			m_CButStop.SetButtonStyle(BS_DEFPUSHBUTTON);
			m_CButStop.SetFocus();

			GetDlgItem(IDC_UDPSERVER)->EnableWindow(FALSE);
			GetDlgItem(IDC_UDPPORT)->EnableWindow(FALSE);
			GetDlgItem(IDC_ADDR_OUT)->EnableWindow(FALSE);
			GetDlgItem(IDC_PORT_OUT)->EnableWindow(FALSE);
			GetDlgItem(IDC_PORT_IN)->EnableWindow(FALSE);
		}
		else								// error
		{
			ASSERT(m_pComObj);				// free Interface class
			delete m_pComObj;
			m_pComObj = nullptr;
		}
	}
}

void CILBlinkyDlg::OnStop()
{
	// TODO: Add your control notification handler code here
	ASSERT(m_pComObj);
	m_pComObj->StopServer();				// quit server thread
}

LRESULT CILBlinkyDlg::OnInterfaceStopped(WPARAM wParam,LPARAM lParam)
{
	// quit message from Interface worker thread
	CInterface *pComObj = reinterpret_cast<CInterface *>(wParam);
	ASSERT(pComObj == m_pComObj);

	ASSERT(m_pComObj);
	delete m_pComObj;
	m_pComObj = nullptr;

	GetDlgItem(IDC_UDPSERVER)->EnableWindow(TRUE);
	GetDlgItem(IDC_UDPPORT)->EnableWindow(TRUE);
	GetDlgItem(IDC_ADDR_OUT)->EnableWindow(TRUE);
	GetDlgItem(IDC_PORT_OUT)->EnableWindow(TRUE);
	GetDlgItem(IDC_PORT_IN)->EnableWindow(TRUE);

	m_CButStop.SetButtonStyle(BS_PUSHBUTTON);
	m_CButStop.EnableWindow(FALSE);
	m_CButStart.EnableWindow(TRUE);
	m_CButStart.SetButtonStyle(BS_DEFPUSHBUTTON);
	m_CButStart.SetFocus();

	return 0;
	UNREFERENCED_PARAMETER(wParam);
	UNREFERENCED_PARAMETER(lParam);
}

void CILBlinkyDlg::OnCancel()
{
	// TODO: Add extra cleanup here
	if (m_pComObj != NULL)					// Interface running
	{
		OnStop();
		PostMessage(WM_COMMAND,IDCANCEL,0);	// call myself, until thread finished
		return;
	}

	// save current settings
	UpdateData(TRUE);

	// get actual window position
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);
	m_nPosX = wndpl.rcNormalPosition.left;
	m_nPosY = wndpl.rcNormalPosition.top;

	TCHAR szAppFile[_MAX_PATH];				// full pathname of application
	GetModuleFileName(NULL,szAppFile,ARRAYSIZEOF(szAppFile));
	WriteString(_T("Run"),_T("App"),szAppFile);

	WriteInt(_T("Settings"),_T("WinPosX"),m_nPosX);
	WriteInt(_T("Settings"),_T("WinPosY"),m_nPosY);

	WriteString(_T("Settings"),_T("AddrOut"),m_strAddrOut);
	WriteInt(_T("Settings"),_T("PortOut"),m_uPortOut);
	WriteInt(_T("Settings"),_T("PortIn"),m_uPortIn);
	WriteInt(_T("Settings"),_T("ConnectTimeout"),m_dwConnectTimeout);

	WriteString(_T("Settings"),_T("UdpServer"),m_strUdpServer);
	WriteInt(_T("Settings"),_T("UdpPort"),m_uUdpPort);

	WriteInt(_T("Settings"),_T("AutoExtAddr"),m_bAutoExtAddr);

	WriteInt   (_T("Settings"),_T("AID"),m_pRedeye->GetAID());
	WriteString(_T("Settings"),_T("ID$"),m_pRedeye->GetID$());

	// write character translation table
	//for (UINT nAddr = 0; nAddr < m_vbyConvert.size(); ++nAddr)
	//{
	//	TCHAR cAddr[8];
	//
	//	wsprintf(cAddr, _T(":%u"), nAddr);
	//	WriteInt(_T("Translate"),cAddr,m_vbyConvert[nAddr]);
	//}

	CDialog::OnCancel();
}
