// ILBlinkyDlg.h : header file
//

#if !defined(AFX_ILBLINKYDLG_H__56234719_F7C6_4ABB_89ED_8BC12146EDE2__INCLUDED_)
#define AFX_ILBLINKYDLG_H__56234719_F7C6_4ABB_89ED_8BC12146EDE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CInterface;							// COM interface object class
class CRedeye;

/////////////////////////////////////////////////////////////////////////////
// CILBlinkyDlg dialog

class CILBlinkyDlg : public CDialog
{
// Construction
public:
	CILBlinkyDlg(CWnd* pParent = NULL);	// standard constructor
	~CILBlinkyDlg();

// Dialog Data
	//{{AFX_DATA(CILBlinkyDlg)
	enum { IDD = IDD_ILBLINKY_DIALOG };
	CButton	m_CButStart;
	CButton	m_CButStop;
	CString m_strUdpServer;
	UINT	m_uUdpPort;
	CString	m_strAddrOut;
	UINT	m_uPortIn;
	UINT	m_uPortOut;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CILBlinkyDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	LRESULT OnInterfaceStopped(WPARAM wParam,LPARAM lParam);

	// Generated message map functions
	//{{AFX_MSG(CILBlinkyDlg)
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnCancel();
	afx_msg void OnStart();
	afx_msg void OnStop();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	LONG	m_nPosX;						// display position
	LONG	m_nPosY;

	std::vector<BYTE> m_vbyConvert;			// character translation table

	DWORD	m_dwConnectTimeout;				// client connect timeout

	BOOL	m_bAutoExtAddr;					// HP-IL auto extended address support

	CInterface *m_pComObj;					// interface object class
	CRedeye    *m_pRedeye;					// Blinky device

	CString	ReadString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault);
	UINT	ReadInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nDefault);
	BOOL	WriteString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszValue);
	BOOL	WriteInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nValue);

	VOID SetWindowLocation(INT nPosX, INT nPosY);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ILBLINKYDLG_H__56234719_F7C6_4ABB_89ED_8BC12146EDE2__INCLUDED_)
