// Redeye.h: interface for the CRedeye class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REDEYE_H__F3F74E8C_92DE_4E11_ADAF_E12BC057C9A6__INCLUDED_)
#define AFX_REDEYE_H__F3F74E8C_92DE_4E11_ADAF_E12BC057C9A6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IldevBase.h"

class CRedeye : public CIldevBase  
{
public:
	CRedeye(const std::vector<BYTE> vbyTranslation, LPCTSTR szUdpServer = _T("localhost"), UINT uUdpPort = 5025, bool bAutoExtAddr = false);
	virtual ~CRedeye();

	void SetInfraredConfiguration(LPCTSTR szUdpServer, UINT uUdpPort);

private:
	std::vector<BYTE> m_vbyTranslation;		// character translation table

	CString m_strUdpServer;
	UINT	m_uUdpPort;

	bool m_bEsc;							// not ESC sequence
	BYTE m_byGraphLength;					// remaining no. of graphic bytes

	IN_ADDR m_ip_addr;						// ipaddress from name

	BYTE ConvertText(BYTE byData);			// convert text
	bool SendByteUdp(BYTE byData);			// send single byte

	VOID ClearDevice() override;			// reset
	VOID InData(WORD wFrame) override;		// listener transfer
};

#endif // !defined(AFX_REDEYE_H__F3F74E8C_92DE_4E11_ADAF_E12BC057C9A6__INCLUDED_)
